532. K-diff Pairs in an Array 数组中差值为k的数对数量

Given an array of integers and an integer k, you need to find the number of unique k-diff pairs in the array. Here a k-diff pair is defined as an integer pair (i, j), where i and j are both numbers in the array and their absolute difference is k.

Example 1:

Input: [3, 1, 4, 1, 5], k = 2
Output: 2
Explanation: There are two 2-diff pairs in the array, (1, 3) and (3, 5).
Although we have two 1s in the input, we should only return the number of unique pairs.

Example 2:

Input:[1, 2, 3, 4, 5], k = 1
Output: 4
Explanation: There are four 1-diff pairs in the array, (1, 2), (2, 3), (3, 4) and (4, 5).

Example 3:

Input: [1, 3, 1, 5, 4], k = 0
Output: 1
Explanation: There is one 0-diff pair in the array, (1, 1).

Note:

  1. The pairs (i, j) and (j, i) count as the same pair.
  2. The length of the array won't exceed 10,000.
  3. All the integers in the given input belong to the range: [-1e7, 1e7].

题目解析:找到差值为给定k的数值对,相同的数值对不重复计数

class Solution {
    public int findPairs(int[] nums, int k) {
        if(k<0)return 0;
        Set<Integer> set1 = new HashSet<Integer>();
        Set<Integer> set2 = new HashSet<Integer>();
        for(int i=0;i<nums.length;i++){
            if(set1.contains(nums[i]+k)){
                set2.add(nums[i]);
            }
            if(set1.contains(nums[i]-k)){
                set2.add(nums[i]-k);
            }
            set1.add(nums[i]);
        }
        return set2.size();
    }
}
设置两个HashSet,一个用来存放数组nums,一个用来存放符合条件的数组对中的较小值,由于HashSet不允许有通相同的数值,所以直接返回HashSet的数值个数即可

class Solution {
    public int findPairs(int[] nums, int k) {
        if(nums == null || nums.length == 0 || k < 0)
            return 0;
        Map<Integer, Integer> map = new HashMap<>();
        for(int n : nums)
            map.put(n, map.getOrDefault(n, 0) + 1);//将数组中的数值放到HashMap中,元素作为键,元素的个数作为值;
        int ans = 0;
        if(k == 0){
            for(int v : map.values())
                if(v > 1)
                    ans++;
        }else{
            for(int key : map.keySet()){
                if(map.containsKey(key + k))
                    ans++;
            }
        }
        return ans;
    }
}

以上这种方法是leetcode上别人分享的,解析如下:

getOrDefault()用于判定如果HashMap中有这个元素n则返回元素n在HashMap中的值,否则返回0,相当于计数放入map中的键的个数

HashMap中put(n,i)是指将键为n,值为i;其中HashMap允许值重复,但是键不能重复

HashMap hashMap = new HashMap();
    hashMap.put("a","1");
    hashMap.put("b","1");
    hashMap.put("a","1");
    System.out.println(hashMap);//值是1可以重复,键是a和b不能重复

HashMap中的values()用于获得其中的值

HashMap中的keySet()用于获取其中的键



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值